【Java】【LeetCode】64. Minimum Path Sum

題目:

Given a m x n grid filled with non-negative numbers, find a path from top left to bottom right which minimizes the sum of all numbers along its path.

Note: You can only move either down or right at any point in time.

Example:

Input:
[
  [1,3,1],
  [1,5,1],
  [4,2,1]
]
Output: 7
Explanation: Because the path 1→3→1→1→1 minimizes the sum.

題解

這道題跟Unique Path系列是思路一樣的。具體思路看代碼就很清楚了

代碼如下:

public class MinimumPathSum {

    public static void main(String[] args) {
        /**
         * Given a m x n grid filled with non-negative numbers, find a path from top
         * left to bottom right which minimizes the sum of all numbers along its path.
         * 
         * Note: You can only move either down or right at any point in time.
         * 
         * Example:
         * 
         * Input: [ [1,3,1], [1,5,1], [4,2,1] ] Output: 7 Explanation: Because the path
         * 1→3→1→1→1 minimizes the sum.
         */
        int[][] grid = { { 1, 3, 1 }, { 1, 5, 1 }, { 4, 2, 1 } };
        System.out.println(minPathSum(grid));
        System.out.println(minPathSum(new int[][] { { 1, 2, 5 }, { 3, 2, 1 } }));// 6
    }

    public static int minPathSum(int[][] grid) {
        if (grid == null || grid.length == 0 || grid[0] == null || grid[0].length == 0) {
            return 0;
        }
        int rowNum = grid.length, colNum = grid[0].length;
        int[][] dp = new int[rowNum][colNum];
        dp[0][0] = grid[0][0];
        for (int i = 1; i < rowNum; i++) {
            dp[i][0] = dp[i - 1][0] + grid[i][0];
        }
        for (int j = 1; j < colNum; j++) {
            dp[0][j] = dp[0][j - 1] + grid[0][j];
        }
        for (int i = 1; i < rowNum; i++) {
            for (int j = 1; j < colNum; j++) {
                dp[i][j] = Math.min(dp[i - 1][j], dp[i][j - 1]) + grid[i][j];
            }
        }
        return dp[rowNum - 1][colNum - 1];
    }

}

 

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章